package main

import (
	"fmt"
	"log"
	"net/http"
	"regexp"

	"github.com/PuerkitoBio/goquery"
)

func main() {
	// Wordpress
	// url := "https://addand.kr/shop/new-%ed%95%9c-%ea%b6%8c%ec%9c%bc%eb%a1%9c-%eb%81%9d%eb%82%98%eb%8a%94-%eb%85%b8%ec%85%98/"

	url := "https://www.fredperry.com/men/sharp/glitch-chequerboard-cardigan-k6512-q41.html"
	url = "https://taiwan.coach.com/cm538-lhslv.html" //Magento

	// url= "https://www.elcanto.co.kr" //MakeShop
	// url= "https://www.ippngirl.co.kr" //MakeShop
	// url= "https://lachinatakorea.com" //Godomall
	// url= "https://sf-fd.com" //Godomall
	// url= "https://p2u.daboryhost.com" /DaboryShop
	// Send an HTTP GET request to the URL
	response, err := http.Get(url)
	if err != nil {
		log.Fatal(err)
	}
	defer response.Body.Close()

	doc, err := goquery.NewDocumentFromReader(response.Body)
	if err != nil {
		log.Fatal(err)
	}
	// These will the value of PDP parsing structures
	cItemName := ".page-title-wrapper.product>.page-title"
	cShortDesc := ".product.attribute.description"
	cItemCategory := ".posted_in"
	cItemTags := ".tagged_as"
	cItemImages := ".product-item-info a"
	cItemTextDesc := ".product-info-descriptions"
	// // cItemOptions := "select#rating option"
	cItemPrice := ".price-wrapper>.price"
	cEmail := "footer"
	cRating := ".star-rating .rating"
	cAuthor := ".product-brand a"
	cVideo := "iframe"

	// Use the Find method to select elements that match the css selector
	// doc.Find(cItemName).Each(func(index int, element *goquery.Selection) {
	// 	// Extract the text associated with the selected element
	// 	text := element.Text()
	// 	fmt.Printf("Text associated with %s: %s\n", cItemName, text)
	// })

	doc.Find("meta").Each(func(i int, s *goquery.Selection) {
		v, _ := s.Attr("property")
		if v == "author" {
			fmt.Println("Author : ", s.AttrOr("content", ""))
		}

		if v == "og:title" {
			fmt.Println("ItemName: ", s.AttrOr("content", ""))
		}

		if v == "og:description" {
			fmt.Println("TextDesc: ", s.AttrOr("content", ""))
		}

		if v == "og:image" {
			fmt.Println("Images: ", s.AttrOr("content", ""))
		}

		// fmt.Println()
	})
	fmt.Println("ItemName: ", doc.Find(cItemName).First().Text())
	fmt.Println("ShortDesc: ", doc.Find(cShortDesc).First().Text())
	fmt.Println("ItemCategory: ", doc.Find(cItemCategory).First().Text())
	fmt.Println("ItemTags: ", doc.Find(cItemTags).First().Text())

	fmt.Println("TextDesc: ", doc.Find(cItemTextDesc).First().Text())
	fmt.Println("ItemPice: ", doc.Find(cItemPrice).First().Text())
	fmt.Println("Email: ", findEmail(doc.Find(cEmail).First().Text(), ""))
	fmt.Println("Rating : ", doc.Find(cRating).First().Text())

	fmt.Println("Author : ")
	doc.Find(cAuthor).Each(func(index int, element *goquery.Selection) {
		link, _ := element.Attr("href")
		fmt.Println("====================")
		fmt.Println("AuthorName: ", element.Text())
		fmt.Printf("AuthorLink: %s\n", link)
	})

	vdos := []string{}
	doc.Find(cVideo).Each(func(index int, element *goquery.Selection) {
		embed, _ := element.Attr("src")
		vdos = append(vdos, embed)
	})
	fmt.Printf("ItemVideos: %s\n", vdos)

	imgs := []string{}
	doc.Find(cItemImages).Each(func(index int, element *goquery.Selection) {
		img, _ := element.Attr("href")
		imgs = append(imgs, img)
	})
	fmt.Println("ItemImages: ", imgs)
}

func findEmail(body string, doms string) (emails []string) {
	r, _ := regexp.Compile(`[a-zA-Z0-9_+&*-]+(?:\.[a-zA-Z0-9_+&*-]+)*@(?:[a-zA-Z0-9-]+\.)+[a-zA-Z]{2,24}`)
	emails = append(emails, r.FindStringSubmatch(body)...)

	return
}
